"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var HandleBars = require("handlebars");
var path = require("path");
var main_module_1 = require("./engine/main-module");
var Dialog = /** @class */ (function () {
    function Dialog() {
    }
    Dialog.html = function (context) {
        return new Promise(function (resolve, reject) {
            fs.readFile(context.filepath, 'utf-8', function (err, code) {
                if (err) {
                    return reject(err);
                }
                var mainModule = new main_module_1.MainModule(context);
                var packagePath = path.join(mainModule.dir, "package.json");
                fs.readFile(packagePath, 'utf-8', function (err, body) {
                    console.log(err);
                    var metadata = JSON.parse(body);
                    var iconPath = path.join(mainModule.dir, "icon.png");
                    fs.readFile(iconPath, function (err, icon) {
                        if (err) {
                            console.error(err);
                        }
                        var template = HandleBars.compile(code);
                        context.title = metadata.name;
                        context.description = metadata.description;
                        if (icon) {
                            context.icon = "data:image/jpeg;base64," + new Buffer(icon).toString("base64");
                        }
                        resolve(template(context));
                    });
                });
            });
        });
    };
    return Dialog;
}());
exports.Dialog = Dialog;
