"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var channel_1 = require("./channel");
var logger_1 = require("./logger");
var Viber = /** @class */ (function (_super) {
    __extends(Viber, _super);
    function Viber(params) {
        return _super.call(this, {
            homedir: params.homedir,
            uid: params.uid,
            platform: 'viber'
        }) || this;
    }
    Viber.prototype.accountInfo = function () {
        return new Promise(function (resolve) {
            var url = "https://chatapi.viber.com/pa/get_account_info";
            var options = {
                json: true,
                url: url,
                headers: {
                    "X-Viber-Auth-Token": process.env.RECIME_VIBER_ACCESS_TOKEN
                },
                body: {}
            };
            request(options, function (err, response, result) {
                resolve(result);
            });
        });
    };
    Viber.prototype.execute = function (body, parameters, handler) {
        var _this = this;
        return new Promise(function (resolve) {
            _this.accountInfo().then(function (user) {
                logger_1.Logger.init(_this.params).then(function (logger) {
                    logger.incoming(body);
                    handler(_this.params.uid, body, "viber", function (result) {
                        // force to array. 
                        result = result.length ? result : [result];
                        _this.sendMessage(0, user, body, result, logger).then(function () {
                            resolve();
                        });
                    });
                });
            });
        });
    };
    Viber.prototype.sendMessage = function (index, user, body, result, logger) {
        var _this = this;
        var method = "send_message";
        return new Promise(function (resolve, reject) {
            var message = result[index];
            var sender = body.sender || body.user;
            message.receiver = sender.id;
            message.tracking_data = _this.params.uid;
            message.sender = {
                name: user.name,
                avatar: "https://icons.recime.io/" + _this.params.uid
            };
            message.type = message.type || "text";
            var url = "https://chatapi.viber.com/pa/" + method;
            var options = {
                json: true,
                url: url,
                headers: {
                    "X-Viber-Auth-Token": process.env.RECIME_VIBER_ACCESS_TOKEN
                },
                body: message
            };
            request(options, function (err, response, r) {
                logger.outgoing(options, r);
                if (index + 1 < result.length) {
                    _this.sendMessage(++index, user, body, result, logger).then(resolve);
                }
                else {
                    return resolve();
                }
            });
        });
    };
    return Viber;
}(channel_1.Channel));
exports.Viber = Viber;
