import fs = require("fs");
import path = require('path');

let mappings = [];

export class MainModule { 
   private botdir: any;
   private options: any;

   constructor(options){
        this.options = options;
        const botdir = path.join(options.homedir,"bot");
       
        if (fs.existsSync(botdir))
            this.botdir = botdir;
        else
            this.botdir = path.join(options.homedir, options.uid);
   }

   get dir() {
        return this.botdir;
   }

   path(){
    return path.join(this.botdir, "main.js");
   }

   normalizedDepsPath(module){
        if (mappings[module]){
            return mappings[module];
        }

        path.join(this.botdir, "node_modules");

        const modulesPath = path.join(this.botdir, "node_modules");
      
        if (module && module.charAt(0) === ".")
            mappings[module] = path.resolve(this.botdir, module);
        else if (fs.existsSync(path.resolve(modulesPath, module)))
            mappings[module] = path.resolve(modulesPath, module);
        else
            mappings[module] = module;
            
        return mappings[module];
   }
}
