import {Runnable} from "./run";

export class Script {

    execute(options:any){
        return new Promise((resolve, reject)=>{
            let runnable = new Runnable(options);

            let timer = setTimeout(()=> {
                reject({
                     message : "Request Timeout"
                });
            }, (15 *1000)); 

            runnable.run(options.data).then((data)=>{
                clearTimeout(timer);
                // resolve
                resolve(data);
            }, (err)=>{
                reject(err);
            });
        });
    }
}