import fs = require("fs");

export class Package {
    private uid: any;

    constructor(uid){
        this.uid = uid;
    }

    readMetadata(){
        return new Promise((resolve, reject)=>{
            const filePath = `${process.env.HOME_DIR || __dirname}/${this.uid}/package.json`;

            fs.readFile(filePath, 'utf-8', (err, data)=>{
                if (err){
                    reject(err);
                } else {
                    const json = JSON.parse(data);

                    resolve({
                        name : json.name,
                        title: json.title,
                        owner: json.owner
                    });
                }
            });
        });
    }
}
