import {Channel} from './channel';
import {Logger} from "./logger";

export class Twilio extends Channel {
    private logger: any;
   
    constructor(params: any){
        super({
            homedir : params.homedir,
            uid : params.uid,
            platform : 'twilio'
        });
    }
    execute(body, parameters, handler){
        return new Promise((resolve, reject)=>{
            Logger.init(this.params).then((logger)=>{
                handler(this.params.uid, body, "twilio", (data)=>{
                    const response = {
                        "Message" : {
                            "Body" : data.text
                        }
                    };
                    resolve(response); 
                }, (err)=> {
                    reject(err);
                });
            });
        });
    }
}