import xml2js = require('xml2js');

export class XML {
    static ifConvert(data){
        return new Promise((resolve, reject)=>{
            if (typeof data === 'object'){
                return resolve(data);
            } 

            const match = data.match(/<xml>[\s\S]*?<\/xml>/g);

            if (match && match.length){
                let parser = xml2js.Parser({
                    trim : true,
                    explicitArray : false
                });
                parser.parseString(data, (err, result)=>{
                    if (err){
                        resolve(err);
                    } else{
                        resolve(result.xml);
                    }
                });
            } else {
                return resolve(data);
            }
        });
    }
}
