import assert = require('assert');
import {SchemaValidator} from "../src/schema-validator";

describe('facebook', ()=> {
  describe('findOne()', ()=> {
    it('should validate', function() {
      const data = {
          "object": "page",
          "entry": [
              {
                  "id": "469698270033296",
                  "time": 1508870253685,
                  "messaging": [
                      {
                          "sender": {
                              "id": "1638652842871803"
                          },
                          "recipient": {
                              "id": "469698270033296"
                          },
                          "timestamp": 1508870253200,
                          "message": {
                              "mid": "mid.$cAAGrMAPvkhZlgPIykFfT6zqMdgcc",
                              "seq": 47465,
                              "text": "hows the weather in San Francisco?"
                          }
                      }
                  ]
              }
          ]
      };
      SchemaValidator.findOne(data).then(function(result) {
        assert.equal(result, "facebook");
      }, function(err) {
          assert.ok(false);
      });
    });
  });
});

describe('slack', ()=> {
    describe('findOne()', ()=> {
      it('should validate', function() {
        var data;
        data = {
          type: "url_verification",
          token: "enBr8Mh1BdVeoGp2FvCxCDl8",
          challenge: "9HaRb9H2dEHT6NGiZFoL6GWQ01qBOJV4XuSkv6U6P3ZL92SznTR6"
        };
        SchemaValidator.findOne(data).then(function(result) {
          assert.equal(result, "slack");
        }, function(err) {
            assert.ok(false);
        });
      });
    });
  });

  describe('wechat', function() {
    describe('validate()', function() {
      it('should resolve the platform', function() {
        var data;
        data = {
          ToUserName: 'to',
          FromUserName: 'from',
          CreateTime: '111333222',
          MsgType: 'text',
          Content: 'Hello World!',
          MsgId: '11111'
        };
        return SchemaValidator.findOne(data).then(function(result) {
          return assert.equal(result, "wechat");
        }, function(err) {
          return assert.ok(false);
        });
      });
    });
  });
