(function() {
  var XML, assert;

  assert = require('assert');

  XML = require(__dirname + '/../xml').XML;

  describe('XML', function() {
    return describe('convert()', function() {
      it('should return json', function() {
        var xml;
        xml = "<xml><ToUserName><![CDATA[toUser]]></ToUserName><FromUserName><![CDATA[fromUser]]></FromUserName> <CreateTime>1348831860</CreateTime><MsgType><![CDATA[text]]></MsgType><Content><![CDATA[this is a test]]></Content><MsgId>1234567890123456</MsgId></xml>";
        return XML.ifConvert(xml).then(function(json) {
          return assert.equal(json.ToUserName, "toUser");
        }, function(err) {
          throw err;
        });
      });
      it('should assert invalid xml', function() {
        var xml;
        xml = "<xml2></xml2>";
        return XML.ifConvert(xml).then(function(xml) {
          return assert.equal(xml, xml);
        }, function(err) {
          throw err;
        });
      });
      return it('should just return for json', function() {
        var data;
        data = {
          success: true
        };
        return XML.ifConvert(data).then(function(json) {
          return assert.equal(json.success, true);
        }, function(err) {
          throw err;
        });
      });
    });
  });

}).call(this);
